package gq.unurled.raxen.components.entity;

import gq.unurled.raxen.Raxen;
import org.bukkit.entity.LivingEntity;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;
import org.jetbrains.annotations.NotNull;

import static gq.unurled.raxen.utils.Utils.debug;

public class EntityUtils {

    private static Raxen main;
    private static EntityNamespacedKey namespacedKey;

    public EntityUtils(Raxen main) {
        this.main = main;
        namespacedKey = new EntityNamespacedKey(main);
    }

    public static void setNameSpacedKeys(org.bukkit.entity.@NotNull Entity e, String name, Integer level, int health, int itemHealth, int defense, int itemDefense, int speed, int itemSpeed, int strength, int itemDmg) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, health);
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, itemHealth);
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, speed);
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, itemSpeed);
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, defense);
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, itemDefense);
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, strength);
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, itemDmg);
        data.set(namespacedKey.nameKey, PersistentDataType.STRING, name);
        data.set(namespacedKey.levelKey, PersistentDataType.INTEGER, level);
    }

    public static void updateSkills(@NotNull LivingEntity livingEntity) {
        Attributes attributes = new Attributes(main);
        int health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg;
        org.bukkit.entity.Entity e = livingEntity;
        health = attributes.getHealth(e);
        itemHealth = attributes.getItemHealth(e);
        defense = attributes.getDefense(e);
        itemDefense = attributes.getItemDefense(e);
        speed = attributes.getSpeed(e);
        itemSpeed = attributes.getItemSpeed(e);
        strength = attributes.getStrength(e);
        itemDmg = attributes.getItemStrength(e);
        if (livingEntity.getAttribute(org.bukkit.attribute.Attribute.GENERIC_FLYING_SPEED) != null) {
            livingEntity.getAttribute(org.bukkit.attribute.Attribute.GENERIC_FLYING_SPEED).setBaseValue((float) (0.0 + ((speed + itemSpeed) / 100) * 0.2));
        }
        if (livingEntity.getAttribute(org.bukkit.attribute.Attribute.GENERIC_MOVEMENT_SPEED) != null) {
            livingEntity.getAttribute(org.bukkit.attribute.Attribute.GENERIC_MOVEMENT_SPEED).setBaseValue((float) (0.0 + ((speed + itemSpeed) / 100) * 0.2));
        }
        livingEntity.getAttribute(org.bukkit.attribute.Attribute.GENERIC_MAX_HEALTH).setBaseValue(20D + (health + itemHealth) / 100);
        debug(main, "Speed " + (speed + itemSpeed), "Health " + (health + itemHealth), "Defense " + (defense+itemDefense), "Strength " + (strength+itemDmg));
    }

}
