package gq.unurled.raxen.manager.server;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.commands.RaxenCommand;
import gq.unurled.raxen.commands.admin.*;
import gq.unurled.raxen.commands.player.ClassCommand;
import gq.unurled.raxen.commands.player.SkillsCommand;
import gq.unurled.raxen.commands.player.StorageCommand;
import lombok.Getter;


public class CommandManager {

    private Raxen main;
    @Getter
    private ItemListCommand itemListCommand;
    private ReloadCommand reloadComand = new ReloadCommand();
    private NbtCommand nbtCommand;
    private TestGuiCommand testGuiCommand = new TestGuiCommand();
    private StorageCommand storageCommand = new StorageCommand();
    private SkillsCommand skillsCommand;
    private RaxenCommand raxenCommand;
    private SpawnEntity entityspawn;
    private ClassCommand classCommand;

    public CommandManager(Raxen main) {
        this.main = main;
        this.itemListCommand = new ItemListCommand(this.main);
        this.nbtCommand = new NbtCommand(this.main);
        this.entityspawn = new SpawnEntity(this.main);
        this.classCommand = new ClassCommand(this.main);
        this.skillsCommand = new SkillsCommand(main);
        this.raxenCommand = new RaxenCommand(main);
    }

    public void register() {
        main.getCommand("reloadplugin").setExecutor(reloadComand);
        main.getCommand("reloadplugin").setTabCompleter(reloadComand);

        main.getCommand("nbt").setExecutor(nbtCommand);
        main.getCommand("nbt").setTabCompleter(nbtCommand);

        main.getCommand("testgui").setExecutor(testGuiCommand);
        main.getCommand("testgui").setTabCompleter(testGuiCommand);

        main.getCommand("storage").setExecutor(storageCommand);
        main.getCommand("storage").setTabCompleter(storageCommand);


        main.getCommand("skills").setTabCompleter(skillsCommand);
        main.getCommand("skills").setExecutor(skillsCommand);

        main.getCommand("raxen").setTabCompleter(raxenCommand);
        main.getCommand("raxen").setExecutor(raxenCommand);

        main.getCommand("itemlist").setExecutor(itemListCommand);
        main.getCommand("itemlist").setTabCompleter(itemListCommand);

        main.getCommand("entityspawn").setTabCompleter(entityspawn);
        main.getCommand("entityspawn").setExecutor(entityspawn);

        main.getCommand("class").setTabCompleter(classCommand);
        main.getCommand("class").setExecutor(classCommand);
    }

}
